%% Plot 

prob = 'lcsh2wiki-small'; upperb = 323;
%prob = 'lcsh2wiki-big'; upperb = 17608;
%prob = 'dmela-scere'; upperb = 381;
%prob = 'musm-homo'; upperb = 1087;

load(sprintf('%s-isorank',prob));
load(sprintf('%s-bp',prob));
load(sprintf('%s-llp',prob));
load(sprintf('%s-mwm',prob));

%% Fix the figures
set(0, ...
    'defaultaxesfontsize',   12, ...
    'defaultaxeslinewidth',   0.7, ...
    'defaultlinelinewidth',   0.8, ...
    'defaultpatchlinewidth',  0.7)

%%
allhist = [];
for i=1:length(bpresults)
    allhist = [allhist; bpresults(i).hist];
end
for i=1:length(bpresults)
    allhist = [allhist; bpresults(i).hist];
end

%%

figure(1); clf; hold on; 
for i=1:length(bpresults), h1=plot(bpresults(i).hist(:,1),bpresults(i).hist(:,3),'o','Color',0.5*ones(3,1)); end
for i=1:length(isoresults), h2=plot(isoresults(i).hist(:,1),isoresults(i).hist(:,3),'kx'); end
for i=1:length(llpresults), h3=plot(llpresults(i).hist(:,1),llpresults(i).hist(:,3),'kd'); end
xlabel('Weight'); ylabel('Overlap'); 
legend([h1,h2,h3],'BP','IsoRank','MR','Location','NW');
box on

%%
figure(2); clf; hold on;
maxoverall=[0 0 0];
for i=1:length(bpresults)
    h = bpresults(i).hist;
    maxh = max(h);
    maxoverall=max(maxoverall,maxh);
    h1=plot(maxh(1),maxh(3),'ko');
end
for i=1:length(isoresults)
    h = isoresults(i).hist;
    maxh = max(h);
    maxoverall=max(maxoverall,maxh);
    h2=plot(maxh(1),maxh(3),'kx');
end
for i=1:length(llpresults)
    h = llpresults(i).hist;
    maxh = max(h);
    maxoverall=max(maxoverall,maxh);
    h3= plot(maxh(1),maxh(3),'k*');
end
maxweight = mwmresults(1).hist(1);
xlabel('Weight'); ylabel('Overlap'); 
% lcsh2wiki-small
% ylim
%xlim([50000,65000]); 
plot(maxweight,-1,'k.'); % include the max-weight area
yl = ylim;
xl = xlim;
ylim([0 yl(2)]);
yticks = get(gca,'YTick');
yticks(end+1) = maxoverall(3);
yticks = sort(yticks);
set(gca,'YTick',yticks);
ht=text(0.999*maxweight,0.9*yl(2),sprintf('max weight\n%g',maxweight));
set(ht,'HorizontalAlignment','right');
set(ht,'VerticalAlignment','top')
;ht=text(0.999*xl(2), 0.99*upperb, sprintf('overlap upper bound\n%i',upperb));
set(ht,'HorizontalAlignment','right');
set(ht,'VerticalAlignment','top');
line(maxweight*[1,1],ylim,'Color',0.5*[1,1,1]);
line(xlim,upperb*[1,1],'Color',0.5*[1,1,1]);

box on;
legend([h1,h2,h3],'BP','IsoRank','MR','Location','SW');
print(gcf,sprintf('%s-summary.eps',prob),'-cmyk','-depsc2');
