%% Look for a phase transition in problem solutions

%%
addpath('../misc/gaimc'); % get bfs function
addpath('~/devextern/Clp-1.9.0/');
addpath('../../matlab');


%%

nrep = 10;

theta = 1.8;
n = 400;
q = 0.02;
d = 1;
pns = [linspace(0.5,8,13) 10 12.5 15];
%pns = [linspace(0.5,10,3)];


%%
alpha = 0;
beta = 1;
fvals = zeros(nrep,length(pns));
fvals_ref = zeros(nrep, length(pns));
rvals = zeros(nrep,length(pns));
ncorr = zeros(nrep,length(pns));

rvals_iso = zeros(nrep,length(pns));
ncorr_iso = zeros(nrep,length(pns));

rvals_bp = zeros(nrep,length(pns));
ncorr_bp = zeros(nrep,length(pns));

rvals_llp = zeros(nrep,length(pns));
ncorr_llp = zeros(nrep,length(pns));
fvals_llp = zeros(nrep,length(pns));


for pi = 1:length(pns)
    p = pns(pi)./n;
    % generate the graphs
    cmd = sprintf('./a.out %i %f %f %f',n,theta,q,p);
    system(cmd);
    for ri = 1:nrep
        %[A,B,L] = align_grid_test_data(k,q,p,d);
        A = readSMAT(sprintf('A%i.smat',ri-1));
        B = readSMAT(sprintf('B%i.smat',ri-1));
        Ldata = load(sprintf('L%i.data',ri-1));
        Ldata(:,1)=Ldata(:,1)+1; Ldata(:,2)=Ldata(:,2)+1;
        Ldata(end+1,:)=[n,n,0];
        L = spconvert(Ldata);
        A = A|A';
        B = B|B';
        
        [S,w,li,lj] = netalign_setup(A,B,L);
        
        [xmr status] = netalignmr(S,w,alpha,beta,li,lj,0.4,25,[],5000);
        
        [ma mb mi weight overlap] = mwmround(xmr,S,w,li,lj);
        rvals(ri,pi) = alpha*weight + beta*overlap;
        ncorr(ri,pi) = sum(ma==mb);        
        fvals(ri,pi) = status(3);
        rv = rvals(ri,pi);
        nc = ncorr(ri,pi);
        
        [ma mb mi weight overlap] = mwmround(li==lj,S,w,li,lj);
        fvals_ref(ri,pi) = alpha*weight + beta*overlap;
        
        xbp = netalignbp(S,w,1,2,li,lj);
        [ma mb mi weight overlap] = mwmround(xbp,S,w,li,lj);
        rvals_bp(ri,pi) = alpha*weight + beta*overlap;
        ncorr_bp(ri,pi) = sum(ma==mb);
        
        xiso = isorank(S,w,1,19,li,lj);
        [ma mb mi weight overlap] = mwmround(xiso,S,w,li,lj);
        rvals_iso(ri,pi) = alpha*weight + beta*overlap;
        ncorr_iso(ri,pi) = sum(ma==mb);

        [xllp fupper] = netalign_lagrange(S,w,alpha,beta,li,lj,50);
        [ma mb mi weight overlap] = mwmround(xllp,S,w,li,lj);
        rvals_llp(ri,pi) = alpha*weight + beta*overlap;
        ncorr_llp(ri,pi) = sum(ma==mb);
        fvals_llp(ri,pi) = fupper;
        
        disp([pi pns(pi) ri status(3) rv nc ...
            rvals_bp(ri,pi) ncorr_bp(ri,pi) ...
            rvals_iso(ri,pi) ncorr_iso(ri,pi) ...
            rvals_llp(ri,pi) ncorr_llp(ri,pi) fvals_llp(ri,pi)])
    end
end
save(sprintf('results-n-%i.mat',n), 'pns','fvals','fvals_ref','rvals','ncorr','*_bp','*_llp','*_iso')
return

